=== debian/changelog ===
plastimatch (1.9.3+dfsg.1-5) unstable; urgency=medium

  [ Gregory C. Sharp ]
  * Team upload.
  * New upstream version 1.9.3+dfsg.1

  [ Mohammed Bilal ]
  * Switch to multi-orig tarball
  * Add autopkgtests
  * New upstream version 1.9.3+dfsg.1
  * Add copyright for test data

 -- Mohammed Bilal <mdbilal@disroot.org>  Mon, 01 Aug 2022 16:58:35 +0530

plastimatch (1.9.3+dfsg.1-4) unstable; urgency=medium

  * Rebuild against dcmtk 3.6.7
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 17 Jun 2022 22:08:42 +0200

plastimatch (1.9.3+dfsg.1-3) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Switch (Build-)Depends from libinsighttoolkit4-dev to
    libinsighttoolkit5-dev
  * Add missing build dependency on dh addon.
  * Update renamed lintian tag names in lintian overrides.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Enable building with C++17

  [ Étienne Mollier ]
  * d/control: build depends on libinsighttoolkit5-dev (>= 5.2.1-4) to get
    ITKReview module support.
  * Add gcc-11.patch: fix ftbfs with gcc-11
    Closes: #1005485

 -- Étienne Mollier <emollier@debian.org>  Thu, 28 Apr 2022 12:28:28 +0200

plastimatch (1.9.3+dfsg.1-2) unstable; urgency=medium

  [ Adrian Bunk ]
  * dcmtk 3.6.6 requires C++ >= 14 (Closes: #1000224)

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Build-Depends: libcharls-dev

 -- Andreas Tille <tille@debian.org>  Sun, 19 Dec 2021 10:13:23 +0100

plastimatch (1.9.3+dfsg.1-1) unstable; urgency=medium

  * New upstream source
  * Remove obsolete patch

 -- Gregory C. Sharp <gregsharp.geo@yahoo.com>  Thu, 21 Jan 2021 10:20:11 -0500
